(function($){
  'use static';
  window.$tbnCtrlSee = window.$tbnCtrlSee || {};
  $tbnCtrlSee.messages = {
    header: "This is copyrighted material!",
    beforeCopyMessage: "<strong>After this short video advertisement you can copy the content to your clipboard. </strong><br> Personal use is permitted. If you would like to use it for commercial purposes please contact us" + ($tbnCtrlSee.contactLink?" <a href='" + $tbnCtrlSee.contactLink + "'><strong><u>here</u></strong></a>":"") + ".",
    afterCopyMessage: "Thank you for watching this short video. It helps cover the cost of providing quality content.",
    copyInstructions: "You are now free to copy this content for your personal use below. Select the text in the box below and copy to clipboard.",
    advertisement: "Powered by <img src='//delivery.thebloggernetwork.com/tbn.png'> <a href='http://www.monumetric.com'>Monumetric</a>"
  };
  $tbnCtrlSee.inject = function(url, callback){
    var e = document.createElement('script');
    if(callback){
      e.onload = callback;
    }
    e.type = 'text/javascript';
    e.src = url;
    document.head.appendChild(e);
  };
  $tbnCtrlSee.getSelection = function(){
    if (window.getSelection) {
      return window.getSelection().toString();
    }
    else if (document.getSelection) {
      return document.getSelection().toString();
    }
    else if (document.selection) {
      return document.selection.createRange().text;
    }
  };
  $tbnCtrlSee.clearSelection = function(){
    if (window.getSelection) {
      if (window.getSelection().empty) {
        window.getSelection().empty();
      }
      else if (window.getSelection().removeAllRanges) {
        window.getSelection().removeAllRanges();
      }
    }
    else if (document.selection) {
      document.selection.empty();
    }
  };
  $tbnCtrlSee.close = function(){
    jwplayer("tbnControlSeeVideoHolder").stop();
    $tbnCtrlSee.$(".tbnCtrlSeePlugin").remove();
  };
  $tbnCtrlSee.onComplete = function(){
    $(".tbnCtrlSeePlugin .before, .tbnCtrlSeePlugin #tbnControlSeeVideoHolder_wrapper").hide();
    $(".tbnCtrlSeePlugin .after").show();
    $(".tbnCtrlSeePlugin textarea").focus(function(){
      $(this).select();
    }).mouseup(function(e){
      e.preventDefault();
    });
  };
  $tbnCtrlSee.show = function(){
    var m = $tbnCtrlSee.messages;
    var e = $( '<div class="tbnCtrlSeePlugin">' +
               '  <div class="tbnCtrlSeePluginWrapper">' +
               '    <div class="tbnCtrlSeePluginHeaderWrapper">' +
               '      <h1>' + m.header + '</h1>' +
               '      <a href="javascript:void(0);" onclick="$tbnCtrlSee.close();">x</a>' +
               '    </div>' +
               '    <div class="tbnCtrlSeePluginBodyWrapper">' +
               '      <div class="before">' + m.beforeCopyMessage + '</div>' +
               '      <div class="after">' + m.afterCopyMessage + '</div>' +
               '      <div class="after">' + m.copyInstructions + '</div>' +
               '      <div class="before" id="tbnControlSeeVideoHolder"></div>' +
               '      <div class="after"><textarea></textarea></div>' +
               '    </div>' +
               '    <div class="after tbnCtrlSeePluginFooterWrapper">' +
               '      <span class="tbnCtrlSeePluginFooterAdvertisement">' + m.advertisement + '</span>' +
               '      <div><label><input type="button" value="Close" onclick="$tbnCtrlSee.close();"></label></div>' +
               '    </div>' +
               '  <div>' +
               '</div>');

    $(e).find( ".after" ).hide();
    $(e).find( "textarea" ).val($tbnCtrlSee.getSelection());
    $tbnCtrlSee.clearSelection();
    $( "body" ).append(e);
    jwplayer( "tbnControlSeeVideoHolder" ).setup({
      "file": $tbnCtrlSee.videoUrl,
      "primary": "flash",
      "controls": false,
      "autostart": true,
      "advertising": {
        "client": "vast",
        "tag": $tbnCtrlSee.vastUrls
      }
    }).onComplete($tbnCtrlSee.onComplete).onAdClick(function(){
      window.setTimeout($tbnCtrlSee.onComplete, 100)
    });
  }

  $tbnCtrlSee.init = function($){
    $(document).ready(function(){
      if(!$tbnCtrlSee.elementSelector || !$tbnCtrlSee.videoUrl || !$tbnCtrlSee.vastUrls || !Array.isArray($tbnCtrlSee.vastUrls) || $tbnCtrlSee.vastUrls.length == 0){
        return null;
      }
      $($tbnCtrlSee.elementSelector).bind({copy : $tbnCtrlSee.show});
    });
  };
  if(!$){
    $tbnCtrlSee.inject("//ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js", function(){
      $tbnCtrlSee.$ = jQuery.noConflict(true);
      $tbnCtrlSee.init($tbnCtrlSee.$);
    });
  } else {
    $tbnCtrlSee.$ = $;
    $tbnCtrlSee.init($);
  }
})(window.jQuery);
